examples/fips_validation: support self-test only
[dpdk.git] / devtools / check-abi.sh
index 0b4d1a3..ab6748c 100755 (executable)
@@ -40,8 +40,8 @@ for dump in $(find $refdir -name "*.dump"); do
        # skip glue drivers, example librte_pmd_mlx5_glue.dump
        # We can't rely on a suppression rule for now:
        # https://sourceware.org/bugzilla/show_bug.cgi?id=25480
-       if [ "$name" != "${name%%_glue.dump}" ]; then
-               echo "Skipping ${dump}..."
+       if grep -qE "\<soname='[^']*_glue\.so\.[^']*'" $dump; then
+               echo "Skipped glue library $name."
                continue
        fi
        dump2=$(find $newdir -name $name)
@@ -50,10 +50,22 @@ for dump in $(find $refdir -name "*.dump"); do
                error=1
                continue
        fi
-       if ! abidiff $ABIDIFF_OPTIONS $dump $dump2; then
+       abidiff $ABIDIFF_OPTIONS $dump $dump2 || {
+               abiret=$?
                echo "Error: ABI issue reported for 'abidiff $ABIDIFF_OPTIONS $dump $dump2'"
                error=1
-       fi
+               echo
+               if [ $(($abiret & 3)) -ne 0 ]; then
+                       echo "ABIDIFF_ERROR|ABIDIFF_USAGE_ERROR, this could be a script or environment issue."
+               fi
+               if [ $(($abiret & 4)) -ne 0 ]; then
+                       echo "ABIDIFF_ABI_CHANGE, this change requires a review (abidiff flagged this as a potential issue)."
+               fi
+               if [ $(($abiret & 8)) -ne 0 ]; then
+                       echo "ABIDIFF_ABI_INCOMPATIBLE_CHANGE, this change breaks the ABI."
+               fi
+               echo
+       }
 done
 
 [ -z "$error" ] || [ -n "$warnonly" ]